d3.json("newrectanglenames.json", function(names) {

d3.json("newrectangleingredients1.json", function(ingredients1) {

d3.json("newrectangleingredients2.json", function(ingredients2) {
	
d3.json("newrectanglecompounds.json", function(compounds) {
													   
d3.json("newrectangleconnections.json", function(connections) {

d3.json("newrectanglelabels.json", function(labels) {

	var colorscheme = "summer";
	var color = [];
	
	if (colorscheme === "blue") {
	
		color[0] = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
		color[1] = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
		color[2] = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
		color[3] = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
		color[4] = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
		color[5] = "rgb(" + Math.floor(Math.random() * 25 + 25) + "," + Math.floor(Math.random() * 200 + 50) + "," + Math.floor(Math.random() * 55 + 200) + ")";
		
	}
	
	if (colorscheme === "vanilla") {
		
		color[0] = "rgb(255, 255, 255)";
		color[1] = "rgb(255, 255, 255)";
		color[2] = "rgb(234, 173, 40)";
		color[3] = "rgb(215, 171, 108)";
		color[4] = "rgb(127, 133, 35)";
		color[5] = "rgb(251, 235, 215)";
		
	}
	
	if (colorscheme === "summer") {
		
		color.push("rgb(255, 253, 238)");
		color.push("rgb(254, 251, 182)");
		color.push("rgb(210, 230, 161)");
		color.push("rgb(122, 189, 158)");
		color.push("rgb(65, 119, 129)");
		color.push("rgb(161, 190, 232)");
		
	}
	
	if (colorscheme === "olive") {
		
		color[0] = "rgb(129, 131, 31)";
		color[1] = "rgb(6, 136, 63)";
		color[2] = "rgb(129, 131, 31)";
		color[3] = "rgb(251, 235, 215)";
		color[4] = "rgb(6, 134, 63)";
		color[5] = "rgb(233, 174, 43)";
		
	}	
	
	for (var i = 0; i < ingredients1.length; i++) {

		ingredients1[i].push(color[Math.floor(Math.random() * 6)]);

	}

	for (var i = 0; i < ingredients2.length; i++) {

		ingredients2[i].push(color[Math.floor(Math.random() * 6)]);

	}
	
	for (var i = 0; i < connections.length; i++) {

		for (var j = 0; j < ingredients1.length; j++) {

			if (connections[i][0] === ingredients1[j][0]) {

				ingredients1[j].push(connections[i][1]);
			
			}

		}

		for (var j = 0; j < ingredients2.length; j++) {

			if (connections[i][0] === ingredients2[j][0]) {

				ingredients2[j].push(connections[i][1]);
			
			}

		}

	}

	
	/*{"names": {"first": "Shrimp scampi and tomato broil", "second": "Seasoned mussels"}, 
	"ingredients": {"first": [["shrimp", 2.75, "rgb(150, 184, 253)", "1-penten-3-ol", "isobutyl acetate", "lauric acid", "propionaldehyde"],
						["white wine", 3.5, "rgb(97, 0, 0)", "2-hexenal", "3-hexen-1-ol", "4-methylpentanoic acid", "alpha-terpineol", "ethyl propionate", "isoamyl alcohol", "nonanoic acid", "propionaldehyde", "phenethyl alcohol", "lauric acid", "isobutyl alcohol", "hexyl alcohol", "l-malic acid", "methyl butyrate", "methyl hexanoate"],
						["mozzarella", 2.5, "rgb(255, 255, 255)", "4-methylpentanoic acid", "alpha-terpineol", "ethyl propionate", "hexyl alcohol", "isoamyl alcohol", "isobutyl acetate", "isobutyl alcohol", "lauric acid", "methyl butyrate", "methyl hexanoate", "nonanoic acid", "phenethyl alcohol"],
						["parmesan", 4.5, "rgb(255, 255, 255)", "1-penten-3-ol", "4-methylpentanoic acid", "alpha-terpineol", "ethyl propionate", "isoamyl alcohol", "isobutyl alcohol", "nonanoic acid", "phenethyl alcohol", "methyl butyrate", "methyl hexanoate"],
						["olive oil", 15, "rgb(106, 128, 30)", "methyl hexanoate"],
						["parsley", 8, "rgb(188, 255, 63)", "3-hexen-1-ol", "alpha-terpineol", "p-mentha-1,3-diene", "p-menth-1-ene-9-al"],
						["garlic", 38, "rgb(60, 185, 10)", "hexyl alcohol", "propionaldehyde", "propyl disulfide"],
						["tomato", 15, "rgb(60, 185, 10)", "1-penten-3-ol", "2-hexenal", "2-isobutyl thiazole", "2,4-nonadienal", "3-hexen-1-ol", "4-methylpentanoic acid", "alpha-terpineol", "cis-3-hexenal", "ethyl propionate", "hexyl alcohol", "isobutyl alcohol", "methyl-butyrate", "nonanoic acid", "phenethyl alcohol", "propyl disulfide", "trans, trans-2,4-hexadienal", "terpinyl acetate"]],
					"second": [["scallion", 6, "rgb(60, 185, 10)", "methyl propyl trisulfide", "propenyl propyl disulfide", "propyl disulfide"],
						["sesame oil", 2.5, "rgb(106, 128, 30)", "acetylpyrazine", "hexyl alcohol"],
						["garlic", 38, "rgb(60, 185, 10)", "hexyl alcohol", "propionaldehyde", "propyl disulfide"],
						["starch", 4, "rgb(106, 128, 30)", "beta-cyclodextrin", "dihydroxyacetone"],
						["soy sauce", 5, "rgb(106, 128, 30)", "2,3-diethylpyrazine", "4-hydroxy-5-methyl...", "allyl 2-furoate", "tetrahydrofurfuryl alcohol"],
						["nut", 2.5, "rgb(205, 188, 244)", "dimethyl succinate", "hexyl alcohol", "phenethyl alcohol", "isobutyl alcohol"],
						["black pepper", 14, "rgb(223, 164, 38)", "limonene (d-,l-, and dl-)", "methyl hexanoate", "p-mentha-1,3-diene", "terpinyl acetate"],
						["sake", 2, "rgb(97, 0, 0)", "4-methylpentanoic acid", "ethyl propionate", "lauric acid", "l-malic acid", "nonanoic acid"],
						["mussel", 1.5, "rgb(150, 184, 253)", "4-methylpentanoic acid", "hexyl alcohol", "isoamyl alcohol", "isobutyl acetate", "nonanoic acid"]]},
	"compounds": ["1-penten-3-ol", "2-hexenal", "2-isobutyl thiazole", "2,3-diethylpyrazine",
						"2,4-nonadienal", "3-hexen-1-ol", "4-hydroxy-5-methyl...", "4-methylpentanoic acid",
						"acetylpyrazine", "allyl 2-furoate", "alpha-terpineol", "beta-cyclodextrin",
						"cis-3-hexenal", "dihydroxyacetone", "dimethyl succinate", "ethyl propionate",
						"hexyl alcohol", "isoamyl alcohol", "isobutyl acetate", "isobutyl alcohol",
						"lauric acid", "limonene (d-,l-, and dl-)", "l-malic acid", "methyl butyrate",
						"methyl hexanoate", "methyl propyl trisulfide", "nonanoic acid", "phenethyl alcohol",
						"propenyl propyl disulfide", "propionaldehyde", "propyl disulfide", "p-mentha-1,3-diene",
						"p-menth-1-ene-9-al", "terpinyl acetate", "tetrahydrofurfuryl alcohol",
						"trans, trans-2,4-hexadienal"]}*/
	
	var firstRecipeName = names[0]; // recipes.names.first;
	var secondRecipeName = names[1]; // recipes.names.second;	
	var firstRecipe = ingredients1; // recipes.ingredients.first;			
	var secondRecipe = ingredients2; // recipes.ingredients.second;
	var flavorCompounds = compounds; // recipes.compounds;
	var circlesLabel = labels[0];
	var compoundsLabel = labels[1];
			
	var scaleFactor = 12;
	var w = scaleFactor * 70;
	var h = w;

	var fontSize = scaleFactor * 1.6;
	document.write("<span id='ingredient' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
	document.write("<span id='name' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
	
	var svg = d3.select("body")
				.append("svg")
				.attr("width", w)
				.attr("height", h);
				
	var vis = d3.select("svg")
				.append("svg")
				.attr("width", w)
				.attr("height", h)
				.attr("x", 0)
				.attr("y", 40);
						
	var overlap = 0;
	var circleMargin = scaleFactor / 3.33;


	for (var i = 0; i < firstRecipe.length; i++) {
		
		for (var j = 0; j < secondRecipe.length; j++) {
		
			if (firstRecipe[i][0] === secondRecipe[j][0]) {
				
				overlap = overlap + 2 * scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI) + circleMargin;
				firstRecipe.push(firstRecipe[i]);
				firstRecipe.splice(i, 1);
				secondRecipe.splice(j, 1);
				
			}
			
		}
	
	}
	
	var diameterSum = 0;
	
	for (var i = 0; i < firstRecipe.length; i++) { 
	
		diameterSum = diameterSum + 2 * scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI);
	
	}
	
	var firstRectHeight = circleMargin * (firstRecipe.length + 0.5) + diameterSum;

	diameterSum = 0;
	
	for (var i = 0; i < secondRecipe.length; i++) { 
	
		diameterSum = diameterSum + 2 * scaleFactor * Math.sqrt(secondRecipe[i][1] / Math.PI);
	
	}
	
	var secondRectHeight = circleMargin * (firstRecipe.length + 0.5) + diameterSum + overlap;

	document.getElementById("name").innerHTML = firstRecipeName;
	var stringLength1 = $('#name').width();

	document.getElementById("name").innerHTML = secondRecipeName;
	var stringLength2 = $('#name').width();

	if (stringLength1 > firstRectHeight - overlap / 2 || stringLength2 > secondRectHeight - overlap / 2) {

		var rectX = Math.max(stringLength1, stringLength2) + 20;
	
	} else {

		rectX = 0;

	}

	var rectWidth = scaleFactor * 15;
	var rectY = 45 / 13 * scaleFactor;
	var circleX = rectX + 4.25 * rectWidth / 10;
	var circleY = 0;
	
	vis.append("rect")
		.attr("x", rectX)
		.attr("y", rectY)
		.attr("height", firstRectHeight)
		.attr("width", rectWidth)
		.attr("fill", "rgba(255, 150, 150, 0.5)");
			
	vis.append("rect")
		.attr("x", rectX)
		.attr("y", rectY + firstRectHeight - overlap)
		.attr("height", secondRectHeight)
		.attr("width", rectWidth)
		.attr("fill", "rgba(251, 144, 58, 0.3)");
		
	diameterSum = 0;
	var line1Y = [];
	var line2Y = [];
	var circle1R = [];
	var circle2R = [];
	
	for (var i = 0; i < firstRecipe.length; i++) {
		
		if (i === 0) {
		
			circleY = rectY + scaleFactor * Math.sqrt(firstRecipe[0][1] / Math.PI) + circleMargin;
			diameterSum = 2 * scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI) + circleMargin;
			
		} else {
		
			circleY = rectY + diameterSum + scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI) + circleMargin;
			diameterSum = diameterSum + 2 * scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI) + circleMargin;

		}
		
		line1Y.push(circleY);
		circle1R.push(scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI));
				
		vis.append("circle")
			.attr("r", scaleFactor * Math.sqrt(firstRecipe[i][1] / Math.PI))
			.attr("cx", circleX)
			.attr("cy", circleY)
			.attr("fill", firstRecipe[i][2]);
					
	}
	
	for (var i = 0; i < secondRecipe.length; i++) {
		
		circleY = rectY + diameterSum + scaleFactor * Math.sqrt(secondRecipe[i][1] / Math.PI) + circleMargin;
		diameterSum = diameterSum + 2 * scaleFactor * Math.sqrt(secondRecipe[i][1] / Math.PI) + circleMargin;
		line2Y.push(circleY);
		circle2R.push(scaleFactor * Math.sqrt(secondRecipe[i][1] / Math.PI));

					
		vis.append("circle")
			.attr("r", scaleFactor * Math.sqrt(secondRecipe[i][1] / Math.PI))
			.attr("cx", circleX)
			.attr("cy", circleY)
			.attr("fill", secondRecipe[i][2]);
					
	}
	
	for (var i = 0; i < firstRecipe.length; i++) {
	
		for (var j = 2; j < firstRecipe[i].length; j++) {
			
			for (var k = 0; k < flavorCompounds.length; k++) { 
				
				if (firstRecipe[i][j] === flavorCompounds[k]) {
				
					vis.append("line")
						.attr("x1", rectWidth + rectX)
						.attr("x2", rectWidth * 1.8 + rectX)
						.attr("y1", line1Y[i])
						.attr("y2", -scaleFactor / 3.33 + 5 + rectY + Math.sqrt(firstRecipe[0][1] / Math.PI) * scaleFactor + (firstRectHeight + secondRectHeight - overlap) * k / (flavorCompounds.length))
						.attr("stroke", "lightgrey")
						.attr("stroke-width", scaleFactor / 5);
						
					break;
						
				}
				
			}
			
		}
		
	}
	
	for (var i = 0; i < secondRecipe.length; i++) {
	
		for (var j = 2; j < secondRecipe[i].length; j++) {
			
			for (var k = 0; k < flavorCompounds.length; k++) { 
				
				if (secondRecipe[i][j] === flavorCompounds[k]) {
				
					vis.append("line")
						.attr("x1", rectWidth + rectX)
						.attr("x2", rectWidth * 1.8 + rectX)
						.attr("y1", line2Y[i])
						.attr("y2", -scaleFactor / 3.33 + 5 + rectY + Math.sqrt(firstRecipe[0][1] / Math.PI) * scaleFactor + (firstRectHeight + secondRectHeight - overlap) * k / (flavorCompounds.length))
						.attr("stroke", "lightgrey")
						.attr("stroke-width", scaleFactor / 5);
						
					break;
						
				}
				
			}
			
		}
		
	}
	
	for (var i = 0; i < flavorCompounds.length; i++) {
		
		var thick = 0;
		var n = 0;
		
		for (var j = 0; j < firstRecipe.length; j++) {
			
			for (var k = 2; k < firstRecipe[j].length; k++) {
				
				if (firstRecipe[j][k] === flavorCompounds[i]) {
				
					n++;
					
					if (n > 1) {
						
						thick = 1;
						break;
						
					}
					
				}
				
			}
			
			if (n > 1) {
					
				break;
						
			}
		
		}
		
		if (n < 2) {
		
			for (var j = 0; j < secondRecipe.length; j++) {
				
				for (var k = 2; k < secondRecipe[j].length; k++) {
					
					if (secondRecipe[j][k] === flavorCompounds[i]) {
					
						n++;
						
						if (n > 1) {
							
							thick = 1;
							break;
							
						}
						
					}
					
				}
				
				if (n > 1) {
						
					break;
							
				}
			
			}
			
		}
		
		vis.append("text")
			.text(flavorCompounds[i])
			.attr("font-family", "arial")
			.attr("font-size", 1.2 * scaleFactor)
			.attr("x", rectWidth * 1.8 + rectX)
			.attr("y", 5 + rectY + Math.sqrt(firstRecipe[0][1] / Math.PI) * scaleFactor + (firstRectHeight + secondRectHeight - overlap) * i / (flavorCompounds.length))
			.attr("stroke", "rgba(0, 0, 0, 0.9)")
			.attr("stroke-width", function() {
				if (thick === 1) {
					return 0.04 * scaleFactor;
				} else {
					return 0;
				}
			});
			
	}

	var fontSize = scaleFactor;
	
	for (var i = 0; i < firstRecipe.length; i++) {
		var elem = document.getElementById("ingredient");
		elem.parentNode.removeChild(elem);
		fontSize = 25;
		document.write("<span id='ingredient' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");

		document.getElementById("ingredient").innerHTML = firstRecipe[i][0];
		
		var stringLength = $('#ingredient').width();
		
		if ((rectWidth - circleX) - (circle1R[i] + stringLength) < 20) {
			
			while ((rectWidth - circleX) - (circle1R[i] + stringLength) < 20) {

				fontSize = fontSize - 0.5;
			
				var elem = document.getElementById("ingredient");
				elem.parentNode.removeChild(elem);		
	
				document.write("<span id='ingredient' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
			
				document.getElementById("ingredient").innerHTML = firstRecipe[i][0];
				stringLength = $('#ingredient').width();
	
			}
			
			vis.append("text")
				.text(firstRecipe[i][0])
				.attr("font-family", "arial")
				.attr("font-size", fontSize)
				.attr("x", rectX + rectWidth - 5)
				.attr("text-anchor", "end")
				.attr("y", line1Y[i] + 0.3 * scaleFactor)
				.attr("stroke", "rgba(50, 50, 50, 0.6)")
				.attr("stroke-width", 0.4 / 13 * scaleFactor);

		} else {
			
			vis.append("text")
				.text(firstRecipe[i][0])
				.attr("font-family", "arial")
				.attr("font-size", fontSize)
				.attr("x", rectX + rectWidth - 5)
				.attr("text-anchor", "end")
				.attr("y", line1Y[i] + 0.3 * scaleFactor)
				.attr("stroke", "rgba(50, 50, 50, 0.6)")
				.attr("stroke-width", 0.4 / 13 * scaleFactor);
				
		}
			
	}
			
	for (var i = 0; i < secondRecipe.length; i++) {		
		var elem = document.getElementById("ingredient");
		elem.parentNode.removeChild(elem);
		fontSize = 25;
		document.write("<span id='ingredient' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");

		document.getElementById("ingredient").innerHTML = secondRecipe[i][0];
		
		var stringLength = $('#ingredient').width();
		
		if ((rectWidth - circleX) - (circle2R[i] + stringLength) < 20) {
			
			while ((rectWidth - circleX) - (circle2R[i] + stringLength) < 20) {

				fontSize = fontSize - 0.5;
			
				var elem = document.getElementById("ingredient");
				elem.parentNode.removeChild(elem);		
	
				document.write("<span id='ingredient' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
			
				document.getElementById("ingredient").innerHTML = secondRecipe[i][0];
				stringLength = $('#ingredient').width();
	
			}
			
			vis.append("text")
				.text(secondRecipe[i][0])
				.attr("font-family", "arial")
				.attr("font-size", fontSize)
				.attr("x", rectX + rectWidth - 5)
				.attr("text-anchor", "end")
				.attr("y", line2Y[i] + 0.3 * scaleFactor)
				.attr("stroke", "rgba(50, 50, 50, 0.6)")
				.attr("stroke-width", 0.4 / 13 * scaleFactor);

		} else {
			
			vis.append("text")
				.text(secondRecipe[i][0])
				.attr("font-family", "arial")
				.attr("font-size", fontSize)
				.attr("x", rectX + rectWidth - 5)
				.attr("text-anchor", "end")
				.attr("y", line2Y[i] + 0.3 * scaleFactor)
				.attr("stroke", "rgba(50, 50, 50, 0.6)")
				.attr("stroke-width", 0.4 / 13 * scaleFactor);
				
		}
			
	}
	
	var fontSize = scaleFactor * 1.6;	

	document.getElementById("name").innerHTML = firstRecipeName;
	var stringLength1 = $('#name').width();
	
	document.getElementById("name").innerHTML = secondRecipeName;
	var stringLength2 = $('#name').width();

	if ((stringLength1 + stringLength2) / 2 + 10 < (firstRectHeight + secondRectHeight) / 2 - overlap) {
	
		vis.append("text")
			.text(firstRecipeName)
			.attr("transform", "rotate(270)")
			.attr("x", -(rectY + 0.5 * firstRectHeight))
			.attr("y", rectX + rectWidth * 0.11)
			.attr("font-family", "arial")
			.attr("font-size", fontSize)
			.attr("fill", "rgba(255, 15, 15, 1)")
			.attr("text-anchor", "middle");
		
		vis.append("text")
			.text(secondRecipeName)
			.attr("transform", "rotate(270)")
			.attr("x", -(rectY + 0.5 * secondRectHeight - overlap + firstRectHeight))
			.attr("y", rectX + rectWidth * 0.11)
			.attr("font-family", "arial")
			.attr("font-size", fontSize)
			.attr("fill", "rgb(251, 144, 58)")
			.attr("text-anchor", "middle");
	
	} else {

		while ((stringLength1 + stringLength2) / 2 + 6 > (firstRectHeight + secondRectHeight) / 2 - overlap) {
			
			fontSize = fontSize - 0.5;
			
			var elem = document.getElementById("name");
			elem.parentNode.removeChild(elem);		

			document.write("<span id='name' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");

			document.getElementById("name").innerHTML = firstRecipeName;
			stringLength1 = $('#name').width();
		
			document.getElementById("name").innerHTML = secondRecipeName;
			stringLength2 = $('#name').width();
						
			if ((stringLength1 + stringLength2) / 2 + 6 < (firstRectHeight + secondRectHeight) / 2 - overlap) {
			
				vis.append("text")
					.text(firstRecipeName)
					.attr("transform", "rotate(270)")
					.attr("x", -(rectY + 0.5 * firstRectHeight))
					.attr("y", rectX + rectWidth * 0.11)
					.attr("font-family", "arial")
					.attr("font-size", fontSize)
					.attr("fill", "rgba(255, 15, 15, 1)")
					.attr("text-anchor", "middle");
				
				vis.append("text")
					.text(secondRecipeName)
					.attr("transform", "rotate(270)")
					.attr("x", -(rectY + 0.5 * secondRectHeight - overlap + firstRectHeight))
					.attr("y", rectX + rectWidth * 0.11)
					.attr("font-family", "arial")
					.attr("font-size", fontSize)
					.attr("fill", "rgb(251, 144, 58)")
					.attr("text-anchor", "middle");
			
			}
		}
	}
	
	function remove(id) {
    	return (elem=document.getElementById(id)).parentNode.removeChild(elem);
	}

	var fontSize = 28 / 13 * scaleFactor;
	document.write("<span id='label' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
	document.getElementById("label").innerHTML = circlesLabel;
	var labelLength = $('#label').width();
	elem = document.getElementById('label');
	elem.parentNode.removeChild(elem);	

	while (labelLength > rectWidth - 20) {
		fontSize = fontSize - 1;
		document.write("<span id='label' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
		document.getElementById("label").innerHTML = circlesLabel;
		labelLength = $('#label').width();
		elem = document.getElementById('label');
		elem.parentNode.removeChild(elem);
	}
	
	vis.append("text")
		.text(circlesLabel)
		.attr("x", rectX + rectWidth / 2)
		.attr("text-anchor", "middle")
		.attr("y", scaleFactor * 28 / 13)
		.attr("font-family", "arial")
		.attr("font-size", fontSize)
		.attr("stroke", "rgba(50, 50, 50, 0.5)")
		.attr("stroke-width", 0.2 / 13 * scaleFactor);

	var fontSize = 28 / 13 * scaleFactor;
	document.write("<span id='label' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
	document.getElementById("label").innerHTML = compoundsLabel;
	var labelLength = $('#label').width();
 
	while (labelLength > rectWidth - 35) {
		fontSize = fontSize - 1;
		document.write("<span id='label' style='visibility:hidden; font-family:arial; font-size:" + fontSize + "'></span>");
		document.getElementById("label").innerHTML = compoundsLabel;
		labelLength = $('#label').width();
		elem = document.getElementById('label');
		elem.parentNode.removeChild(elem);
	}		

	vis.append("text")
		.text(compoundsLabel)
		.attr("x", rectWidth * 2 + rectX)
		.attr("text-anchor", "middle")
		.attr("y", scaleFactor * 28 / 13)
		.attr("font-family", "arial")
		.attr("font-size", fontSize)
		.attr("stroke", "rgba(50, 50, 50, 0.5)")
		.attr("stroke-width", 0.2 / 13 * scaleFactor);

	elem = document.getElementById("name");
	elem.parentNode.removeChild(elem);
	elem = document.getElementById("ingredient");
	elem.parentNode.removeChild(elem);
	elem = document.getElementById("label");
	elem.parentNode.removeChild(elem);
				
});

});

});

});

});

});