function plotArrows(brainStruct, coorStart, coorEnd, pv, ArSzLt, projected, bundled, name)

opengl neverselect;

if(~isempty(coorStart))
    %minVal = min(pv); maxVal = max(pv);
    minVal = 0.12; maxVal = 0.34;
    pv = (pv - minVal)/(maxVal-minVal);
    coord = [coorStart coorEnd];
    f1 = figure; clf reset; set(gca, 'Color', 'none'); set(gcf, 'Color', 'none'); grid off;
    activateBrain(brainStruct.cortex, brainStruct.vcontribs, brainStruct.tala, brainStruct.ix, brainStruct.cmapstruct, brainStruct.viewstruct);
    drawdtfconngraph2(coord, pv, ArSzLt, brainStruct.cortexHull, projected, bundled);
else
    f1 = figure; clf reset; set(gca, 'Color', 'none'); set(gcf, 'Color', 'none'); grid off;
    activateBrain(brainStruct.cortex, brainStruct.vcontribs, brainStruct.tala, brainStruct.ix, brainStruct.cmapstruct, brainStruct.viewstruct);
end
zoom(1.5);

if (nargin>7)
    export_fig(name,'-png','-cmyk','-r100',f1);
end
